<?php

/*-----------------------------------------------------------------------------------*/
/*	Load Theme Options
/*-----------------------------------------------------------------------------------*/

	$especial_libraries = 
		array( 
			'theme-options',
			'widgets',
			'breadcrumb',
			'twitter',
			'panels_page',
			'panels_post',

		);
	foreach( $especial_libraries as $library ) {
		include_once( 'libraries/' . $library . '.php' );
	}
	
// Add the Theme Shortcodes
include("libraries/shortcodes.php");

// Add the tinymce button
require_once("libraries/wysiwyg/wysiwyg.php");
	
define('ESPECIAL_TEMPLATE', get_stylesheet_directory_uri());	

add_filter( 'measurement_unit_types', 'custom_unit_types' );

function custom_unit_types($array) 
{
  $array['px'] = 'px';

  return $array;
}



/*-----------------------------------------------------------------------------------*/
/*	Configure WP2.9+ Thumbnails
/*-----------------------------------------------------------------------------------*/

if ( function_exists( 'add_theme_support' ) ) {
	add_theme_support( 'post-thumbnails' );
	set_post_thumbnail_size( 340, 230, true );
	add_image_size( 'large', 680, '', true ); // Large thumbnails
	add_image_size( 'medium', 250, '', true ); // Medium thumbnails
	add_image_size( 'small', 340, 230, true ); // Small thumbnails
	add_image_size( 'thumbnail-post', 625, 300, true ); // Post thumbnails
	add_image_size( 'portfolio-full', 450, 300, true ); // Portfolio Post thumbnails
	add_image_size( 'portfolio-full2', 900, 422, true ); // Portfolio Post full-width
	add_image_size( 'popular_post', 75, 60, true ); // Post thumbnails
	add_image_size( 'homepage2', 193, 139, true ); // Home page 2 thumbnails
	add_image_size( 'search_thumbnail', 110, 65, true ); // Search thumbnails

}

/*-----------------------------------------------------------------------------------*/
/*	Superfish Menu
/*-----------------------------------------------------------------------------------*/


// This theme uses wp_nav_menu() in one location.
		register_nav_menus( array(
			'primary' => __( 'Primary Menu', 'especial' )
		) );
		

// Fallback (Pre 3.0) menu system
	function especial_menu_fallback()
	{
		$menu = "<ul class='sf-menu'>";
		//$menu .= wp_list_pages('echo=0&title_li=');
		$menu .= "<li><a href='#'>" . __( 'Add a menu in Apperance, Menus') . "</a></li>";
		$menu .= "</ul>";
		echo $menu;
	}

/*-----------------------------------------------------------------------------------*/
/*	Change Default Excerpt Length
/*-----------------------------------------------------------------------------------*/


function the_excerpt2($post, $count = 100) {
   if(empty($post)) {
        the_excerpt();
       return false;
    }
	$allowed_tags = '<a>,<i>,<em>,<b>,<strong>,<span>';
    $content = trim(strip_tags($post->post_content, $allowed_tags));
    $content = explode(' ', $content);
    $content = array_slice($content, 0, $count);
    $content = implode(' ', $content);
    $content = preg_replace( '|\[(.+?)\](.+?\[/\\1\])?|s', '', $content);

    
    echo '<p>'.$content.' ...</p>';    return true;
 return true;
 }
 

/*-----------------------------------------------------------------------------------*/
/*	RClean up the <head>
/*-----------------------------------------------------------------------------------*/	

	function removeHeadLinks() {
    	remove_action('wp_head', 'rsd_link');
    	remove_action('wp_head', 'wlwmanifest_link');
    }
    add_action('init', 'removeHeadLinks');
    remove_action('wp_head', 'wp_generator');
    
	
/*-----------------------------------------------------------------------------------*/
/*	Register Sidebars
/*-----------------------------------------------------------------------------------*/


if ( function_exists('register_sidebar') ) {
	
	register_sidebar(array(
		'name' => 'Page Sidebar',
		'before_widget' => '<div class="lside_wiget_box">',
		'after_widget' => '</div>',
		'before_title' => '<div class="lside_wiget_box_title"><span>',
		'after_title' => '</span></div>',
	));
	
	register_sidebar(array(
		'name' => 'Home Page Sidebar',
		'before_widget' => '<div class="lside_wiget_box">',
		'after_widget' => '</div>',
		'before_title' => '<div class="lside_wiget_box_title"><span>',
		'after_title' => '</span></div>',
	));
	
	register_sidebar(array(
		'name' => 'Portfolio sidebar',
		'before_widget' => '<div class="lside_wiget_box">',
		'after_widget' => '</div>',
		'before_title' => '<div class="lside_wiget_box_title"><span>',
		'after_title' => '</span></div>',
	));
	
	register_sidebar(array(
		'name' => 'Blog sidebar',
		'before_widget' => '<div class="lside_wiget_box">',
		'after_widget' => '</div>',
		'before_title' => '<div class="lside_wiget_box_title"><span>',
		'after_title' => '</span></div>',
	));

	register_sidebar(array(
		'name' => 'Contact Page sidebar',
		'before_widget' => '<div class="lside_wiget_box">',
		'after_widget' => '</div>',
		'before_title' => '<div class="lside_wiget_box_title"><span>',
		'after_title' => '</span></div>',
	));	
	

}
	
 
/*-----------------------------------------------------------------------------------*/
/*	Custom Gravatar Support
/*-----------------------------------------------------------------------------------*/

function esp_custom_gravatar( $avatar_defaults ) {
    $esp_avatar = get_template_directory_uri() . '/images/gravatar.gif';
    $avatar_defaults[$esp_avatar] = 'Custom Gravatar (/images/gravatar.gif)';
    return $avatar_defaults;
}
add_filter( 'avatar_defaults', 'esp_custom_gravatar' );



/*-----------------------------------------------------------------------------------*/
/*	Register and load common JS
/*-----------------------------------------------------------------------------------*/

function esp_register_js() {
	if (!is_admin()) {
		// comment out the next two lines to load the local copy of jQuery
		wp_deregister_script('jquery');
		wp_register_script('jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.3/jquery.min.js');
		wp_register_script('superfish', get_template_directory_uri() . '/js/superfish.js', 'jquery');
		wp_register_script('easing', get_template_directory_uri() . '/js/jquery.easing.js', 'jquery');
		wp_register_script('prettyPhoto', get_template_directory_uri() . '/js/jquery.pretty_photo.js', 'jquery');
		wp_register_script('scrollTo', get_template_directory_uri() . '/js/jquery.scrollTo-min.js', 'jquery');
		wp_register_script('color', get_template_directory_uri() . '/js/stylesheetToggle.js', 'jquery');
		wp_register_script('validate', get_template_directory_uri() . '/js/jquery.validate.pack.js', 'jquery');
		wp_register_script('esp_custom', get_template_directory_uri() . '/js/scripts.js', 'jquery');		
		
		wp_enqueue_script('jquery');
		wp_enqueue_script('superfish');
		wp_enqueue_script('easing');
		wp_enqueue_script('prettyPhoto');
		wp_enqueue_script('scrollTo');
		wp_enqueue_script('color');
		wp_enqueue_script('validate');
		wp_enqueue_script('esp_custom');
		
	}
}
add_action('init', 'esp_register_js');


/*-----------------------------------------------------------------------------------*/
/*	YouTube Post Settings
/*-----------------------------------------------------------------------------------*/

function my_strip($start,$end,$total){
$total = stristr($total,$start);
$f2 = stristr($total,$end);
return substr($total,strlen($start),-strlen($f2));
}

/*-----------------------------------------------------------------------------------*/
/*	Vimeo Post Settings
/*-----------------------------------------------------------------------------------*/

function file_get_contents_curl($url) {
$ch = curl_init();
     
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); //Set curl to return the data instead of printing it to the browser.
curl_setopt($ch, CURLOPT_URL, $url);
     
$data = curl_exec($ch);
curl_close($ch);
     
return $data;
}



/*-----------------------------------------------------------------------------------*/
/*	Filters that allow shortcodes in Text Widgets
/*-----------------------------------------------------------------------------------*/

add_filter('widget_text', 'do_shortcode');

?>