<?php

/*-----------------------------------------------------------------------------------*/
/*	Popular Posts Widget
/*-----------------------------------------------------------------------------------*/

class WP_Widget_Custom_Popular_Posts extends WP_Widget {
	
	function WP_Widget_Custom_Popular_Posts() {
		$widget_ops = array('classname' => 'widget_custom_popular_entries', 'description' => __( "The most popular posts on your site") );
		$this->WP_Widget('custom-popular-posts', __('&nbsp;Especial - Popular Posts'), $widget_ops);
		$this->alt_option_name = 'widget_custom_popular_entries';

		add_action( 'save_post', array(&$this, 'flush_widget_cache') );
		add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
		add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
	}

	function widget($args, $instance) {

		ob_start();
		extract($args);

		$title = apply_filters('widget_title', empty($instance['title']) ? __('Popular Posts') : $instance['title'], $instance, $this->id_base);
		if ( !$number = (int) $instance['number'] )
			$number = 10;
		else if ( $number < 1 )
			$number = 1;
		else if ( $number > 15 )
			$number = 15;
			


		$r = new WP_Query(array('showposts' => $number, 'nopaging' => 0, 'post_status' => 'publish', 'caller_get_posts' => 1, 'post_type' => 'post', 'orderby' => 'comment_count'));
		if ($r->have_posts()) :
?>
		<?php echo $before_widget; ?>
		<?php if ( $title ) echo $before_title . $title . $after_title; ?>
        

<?php  while ($r->have_posts()) : $r->the_post(); ?>         
            
            
<div class="wig_postbox">
<a href="<?php the_permalink() ?>">
       
        
<?php global $post; ?>        
<!-- Vimeo -->
<?php if(get_post_meta($post->ID, 'vimeo_embed', true) != NULL) { ?>

<?php if(get_option_tree('video_on_off')) { ?>

<?php $vimeo = preg_replace('/\D*(\d+(\.\d+)?)/', "$1", get_post_meta($post->ID, 'vimeo_embed', true)); ?>
<?php $hash = unserialize(file_get_contents_curl("http://vimeo.com/api/v2/video/$vimeo.php"));?>
<img src="<?php echo $hash[0]['thumbnail_small']; ?>" alt="" width="75" height="60"/>

<?php } else { ?>

<?php $src = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), array( 1000,1000 ), false, '' ); ?>
<?php the_post_thumbnail('popular_post');?>

<?php } ?>  


<!-- Youtube -->
<?php } else if(get_post_meta($post->ID, 'youtube_embed', true) != NULL) { ?>

<?php if(get_option_tree('video_on_off')) { ?>

<?php
$string=get_post_meta($post->ID, 'youtube_embed', true);
$youtube=my_strip("?v=","&",$string);
?>
<img src="http://img.youtube.com/vi/<?php echo $youtube; ?>/0.jpg" width="75" height="60" />

<?php } else { ?>

<?php $src = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), array( 1000,1000 ), false, '' ); ?>
<?php the_post_thumbnail('popular_post');?>

<?php } ?>       




<?php } else { ?>
	<?php if(has_post_thumbnail()) { ?>
    
		<?php $src = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), array( 1000,1000 ), false, '' ); ?>
			<?php the_post_thumbnail('popular_post');?>
        <?php } else { ?>
    <?php } ?>        
<?php } ?>
</a> 
        
<div class="wig_post_right"><a href="<?php the_permalink() ?>"  class="wig_post_title"><?php the_title(); ?></a>
<span><?php the_time('F'); ?> <?php the_time('d'); ?>, <?php the_time('Y'); ?></span><div class="wig_postbox_comm"><a href="<?php the_permalink() ?>#comments" class="wig_postbox_comm_link"><?php comments_number('0','1', '%', 'comment_counter'); ?></a></div>
</div><div class="clear"></div></div>
            
<?php endwhile; ?>

        
<?php echo $after_widget; ?>
<?php
		wp_reset_postdata();

		endif;

		$cache[$args['widget_id']] = ob_get_flush();
		wp_cache_set('widget_custom_popular_posts', $cache, 'widget');
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['number'] = (int) $new_instance['number'];
		$this->flush_widget_cache();

		$alloptions = wp_cache_get( 'alloptions', 'options' );
		if ( isset($alloptions['widget_custom_popular_entries']) )
			delete_option('widget_custom_popular_entries');

		return $instance;
	}

	function flush_widget_cache() {
		wp_cache_delete('widget_custom_popular_posts', 'widget');
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		if ( !isset($instance['number']) || !$number = (int) $instance['number'] )
			$number = 3;
?>
	
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:<br />'); ?>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>

		<p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e('Enter the number of popular posts you\'d like to display:<br /><br />'); ?>
		<input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /><small style="color:#f00; float:right; padding-top:2px;">default is 3</small><br /></label></p>
<?php
	}
}


/*-----------------------------------------------------------------------------------*/
/*	Recent Posts Widget
/*-----------------------------------------------------------------------------------*/

class WP_Widget_Custom_Recent_Posts extends WP_Widget {
	
	function WP_Widget_Custom_Recent_Posts() {
		$widget_ops = array('classname' => 'widget_custom_recent_entries', 'description' => __( "The most recent posts on your site") );
		$this->WP_Widget('custom-recent-posts', __('&nbsp;Especial - Recent Posts'), $widget_ops);
		$this->alt_option_name = 'widget_custom_recent_entries';

		add_action( 'save_post', array(&$this, 'flush_widget_cache') );
		add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
		add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
	}

	function widget($args, $instance) {
		$cache = wp_cache_get('widget_custom_recent_posts', 'widget');


		ob_start();
		extract($args);

		$title = apply_filters('widget_title', empty($instance['title']) ? __('Recent Posts') : $instance['title'], $instance, $this->id_base);
		if ( !$number = (int) $instance['number'] )
			$number = 10;
		else if ( $number < 1 )
			$number = 1;
		else if ( $number > 15 )
			$number = 15;

		$r = new WP_Query(array('showposts' => $number, 'nopaging' => 0, 'post_status' => 'publish', 'caller_get_posts' => 1, 'post_type' => 'post'));
		if ($r->have_posts()) :
?>
		<?php echo $before_widget; ?>
		<?php if ( $title ) echo $before_title . $title . $after_title; ?>
        
        
<?php  while ($r->have_posts()) : $r->the_post(); ?>         
            
            
<div class="wig_postbox">
<a href="<?php the_permalink() ?>">
       
        
<?php global $post; ?>  

<!-- Vimeo -->
<?php if(get_post_meta($post->ID, 'vimeo_embed', true) != NULL) { ?>

<?php if(get_option_tree('video_on_off')) { ?>

<?php $vimeo = preg_replace('/\D*(\d+(\.\d+)?)/', "$1", get_post_meta($post->ID, 'vimeo_embed', true)); ?>
<?php $hash = unserialize(file_get_contents_curl("http://vimeo.com/api/v2/video/$vimeo.php"));?>
<img src="<?php echo $hash[0]['thumbnail_small']; ?>" alt="" width="75" height="60"/>

<?php } else { ?>

<?php $src = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), array( 1000,1000 ), false, '' ); ?>
<?php the_post_thumbnail('popular_post');?>

<?php } ?>  


<!-- Youtube -->
<?php } else if(get_post_meta($post->ID, 'youtube_embed', true) != NULL) { ?>

<?php if(get_option_tree('video_on_off')) { ?>

<?php
$string=get_post_meta($post->ID, 'youtube_embed', true);
$youtube=my_strip("?v=","&",$string);
?>
<img src="http://img.youtube.com/vi/<?php echo $youtube; ?>/0.jpg" width="75" height="60" />

<?php } else { ?>

<?php $src = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), array( 1000,1000 ), false, '' ); ?>
<?php the_post_thumbnail('popular_post');?>

<?php } ?>       




<?php } else { ?>
	<?php if(has_post_thumbnail()) { ?>
    
		<?php $src = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), array( 1000,1000 ), false, '' ); ?>
			<?php the_post_thumbnail('popular_post');?>
        <?php } else { ?>
    <?php } ?>        
<?php } ?>
</a> 




        
<div class="wig_post_right"><a href="<?php the_permalink() ?>"  class="wig_post_title"><?php the_title(); ?></a>
<span><?php the_time('F'); ?> <?php the_time('d'); ?>, <?php the_time('Y'); ?></span>
</div><div class="clear"></div></div>
            
<?php endwhile; ?>
        
        
        
        
        
		<?php echo $after_widget; ?>
<?php
		wp_reset_postdata();

		endif;

		$cache[$args['widget_id']] = ob_get_flush();
		wp_cache_set('widget_custom_recent_posts', $cache, 'widget');
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['number'] = (int) $new_instance['number'];
		$this->flush_widget_cache();

		$alloptions = wp_cache_get( 'alloptions', 'options' );
		if ( isset($alloptions['widget_custom_recent_entries']) )
			delete_option('widget_custom_recent_entries');

		return $instance;
	}

	function flush_widget_cache() {
		wp_cache_delete('widget_custom_recent_posts', 'widget');
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		if ( !isset($instance['number']) || !$number = (int) $instance['number'] )
			$number = 3;
?>
	
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:<br />'); ?>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>

		<p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e('Enter the number of recent posts you\'d like to display:<br /><br />'); ?>
		<input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /><small style="color:#f00; float:right; padding-top:2px;">default is 3</small><br /></label></p>
<?php
	}
}


/*-----------------------------------------------------------------------------------*/
/*	Latest from Twitter Widget
/*-----------------------------------------------------------------------------------*/

class WP_Widget_Custom_Twitter extends WP_Widget {
	
	function WP_Widget_Custom_Twitter() {
		$widget_ops = array('classname' => 'widget_custom_twitter_entries', 'description' => __( "Your account most recent tweets") );
		$this->WP_Widget('custom-twitter', __('&nbsp;Especial - Twitter'), $widget_ops);
		$this->alt_option_name = 'widget_custom_twitter_entries';

		add_action( 'save_post', array(&$this, 'flush_widget_cache') );
		add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
		add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
	}

	function widget($args, $instance) {


		ob_start();
		extract($args);

		$title = apply_filters('widget_title', empty($instance['title']) ? __('Twitter') : $instance['title'], $instance, $this->id_base);
		$usernames = apply_filters('widget_title', empty($instance['usernames']) ? __('') : $instance['usernames'], $instance, $this->id_base);
		if ( !$number = (int) $instance['number'] )
			$number = 10;
		else if ( $number < 1 )
			$number = 1;
		else if ( $number > 15 )
			$number = 15;

		$type = 'widget';
?>

		<?php echo $before_widget; ?>
		
		<?php if ( $title ) echo $before_title . $title . $after_title; ?>
        
<div class="wig_twitbox">

<?php parse_cache_feed($usernames, $number, $type); ?>

</div>

		<?php echo $after_widget; ?>
		
        
        
<?php
		$cache[$args['widget_id']] = ob_get_flush();
		wp_cache_set('widget_custom_twitter', $cache, 'widget');
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['usernames'] = strip_tags($new_instance['usernames']);
		$instance['number'] = (int) $new_instance['number'];
		$this->flush_widget_cache();

		$alloptions = wp_cache_get( 'alloptions', 'options' );
		if ( isset($alloptions['widget_custom_twitter_entries']) )
			delete_option('widget_custom_twitter_entries');

		return $instance;
	}

	function flush_widget_cache() {
		wp_cache_delete('widget_custom_twitter', 'widget');
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$usernames = isset($instance['usernames']) ? esc_attr($instance['usernames']) : '';
		if ( !isset($instance['number']) || !$number = (int) $instance['number'] )
			$number = 3;
?>
	
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:<br />'); ?>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>

		<p><label for="<?php echo $this->get_field_id('usernames'); ?>"><?php _e('Twitter Username:<br />'); ?>
		<input class="widefat" id="<?php echo $this->get_field_id('usernames'); ?>" name="<?php echo $this->get_field_name('usernames'); ?>" type="text" value="<?php echo $usernames; ?>" /></label></p>
		
		<p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e('Enter the number of recent tweets you\'d like to display:<br /><br />'); ?>
		<input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /><small style="color:#f00; float:right; padding-top:2px;">default is 3</small><br /></label></p>
<?php
	}
}

/*-----------------------------------------------------------------------------------*/
/*	Flickr Widget
/*-----------------------------------------------------------------------------------*/

class WP_Widget_Custom_Flickr extends WP_Widget {
	
	function WP_Widget_Custom_Flickr() {
		$widget_ops = array('classname' => 'widget_custom_flickr_entries', 'description' => __( "Your account most recent images") );
		$this->WP_Widget('custom-flickr', __('&nbsp;Especial - Flickr'), $widget_ops);
		$this->alt_option_name = 'widget_custom_flickr_entries';

		add_action( 'save_post', array(&$this, 'flush_widget_cache') );
		add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
		add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
	}

	function widget($args, $instance) {

		ob_start();
		extract($args);

		$title = apply_filters('widget_title', empty($instance['title']) ? __('Flickr') : $instance['title'], $instance, $this->id_base);
		$usernames = apply_filters('widget_title', empty($instance['usernames']) ? __('') : $instance['usernames'], $instance, $this->id_base);
		if ( !$number = (int) $instance['number'] )
			$number = 10;
		else if ( $number < 1 )
			$number = 1;
		else if ( $number > 15 )
			$number = 15;

?>
		<?php echo $before_widget; ?>

		<?php if ( $title ) echo $before_title . $title . $after_title; ?>
			<div class="flickr_wrap">
            <div class="clear"></div>
				<script type="text/javascript" src="http://www.flickr.com/badge_code_v2.gne?count=<?php echo $number; ?>&amp;display=latest&amp;size=s&amp;layout=x&amp;source=user&amp;user=<?php echo $usernames; ?>"></script>        
				<div class="clear"></div>

                
<div class="cont_button"><a href="http://www.flickr.com/photos/<?php echo $usernames; ?>" class="all" target="_blank"><span>All Flickr Images</span></a></div>
<div class="clear"></div>


			</div>
		<?php echo $after_widget; ?>
	
<?php
		$cache[$args['widget_id']] = ob_get_flush();
		wp_cache_set('widget_custom_flickr', $cache, 'widget');
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['usernames'] = strip_tags($new_instance['usernames']);
		$instance['number'] = (int) $new_instance['number'];
		$this->flush_widget_cache();

		$alloptions = wp_cache_get( 'alloptions', 'options' );
		if ( isset($alloptions['widget_custom_flickr_entries']) )
			delete_option('widget_custom_flickr_entries');

		return $instance;
	}

	function flush_widget_cache() {
		wp_cache_delete('widget_custom_flickr', 'widget');
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$usernames = isset($instance['usernames']) ? esc_attr($instance['usernames']) : '';
		if ( !isset($instance['number']) || !$number = (int) $instance['number'] )
			$number = 6;
?>
	
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:<br />'); ?>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>

		<p><label for="<?php echo $this->get_field_id('usernames'); ?>"><?php _e('Flickr ID (<a href="http://www.idgettr.com" target="_blank">idGettr</a>):<br />'); ?>
		<input class="widefat" id="<?php echo $this->get_field_id('usernames'); ?>" name="<?php echo $this->get_field_name('usernames'); ?>" type="text" value="<?php echo $usernames; ?>" /></label></p>
		
		<p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e('Enter the number of recent images you\'d like to display:<br /><br />'); ?>
		<input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /><small style="color:#f00; float:right; padding-top:2px;">default is 6</small><br /></label></p>
<?php
	}
}

/*-----------------------------------------------------------------------------------*/
/*	REGISTER Widgets
/*-----------------------------------------------------------------------------------*/


add_action( 'widgets_init', 'especial_load_widgets' );
function especial_load_widgets()
{

   register_widget( 'WP_Widget_Custom_Popular_Posts' );
   register_widget( 'WP_Widget_Custom_Recent_Posts' );
   register_widget( 'WP_Widget_Custom_Twitter' );
   register_widget( 'WP_Widget_Custom_Flickr' );

}



?>